'use strict';
var SERVER_URL = 'https://api.snapaddy.com/grabberButtons';

// FIXME: Not working at all on http://www.sueddeutsche.de/app/service/impressum/
function getCurrentSelectionAsText() {
  return window.getSelection().toString();
}

function getGrabberButtonDomains(callback) {
  function requestDomains(cb) {
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function () {
      if (xhr.readyState === 4) {
        if (xhr.status === 200) {
          var jsObj = JSON.parse(xhr.responseText);
          cb(jsObj);
        } else {
          cb(null);
        }
      }
    };

    var url = SERVER_URL + '/getDomains';
    xhr.open('GET', url, true);
    xhr.send();
  }

  function storageCallback(obj) {
    var domainObj = obj.domains;

    function req() {
      requestDomains(function (domainArray) {
        if (domainArray) {
          chrome.storage.local.set({
            'domains': {
              list: domainArray,
              lastFetched: new Date().getTime()
            }
          });
          callback(domainArray);
        } else {
          callback([]);
        }
      });
    }

    if (!domainObj) {
      req();
    } else {
      if (!domainObj.lastFetched) {
        req();
      } else {
        var ONE_DAY_IN_MS = 1000 * 60 * 60 * 24;
        //var ONE_DAY_IN_MS = 5000;
        var daysSinceLastFetch = Math.round(Math.abs(new Date(domainObj.lastFetched).getTime() - new Date().getTime()) / ONE_DAY_IN_MS);
        if (daysSinceLastFetch > 1) {
          req();
        } else {
          callback(domainObj.list);
        }
      }
    }
  }

  chrome.storage.local.get('domains', storageCallback);
}

function insertCrocoScript() {
  if (window.location.href.indexOf('chrome-extension') > -1 || window.location.href.indexOf('localhost') > -1) {
    return;
  }


  // check if injected into an iframe and prevent adding the grabber buttons
  if (window.top !== window.self) {
    return;
  }

  getGrabberButtonDomains(function (domains) {
    var addButton = domains.filter(function (item) {
      return new RegExp(item).test(window.location.href);
    }).length > 0;

    if (addButton) {
      document.addEventListener('buttonClick', function (event) {
        var type = event.detail.type;
        var contact = event.detail.contact;
        chrome.runtime.sendMessage({
          leads: true,
          data: {
            type: 'grabBtn',
            msg: type,
            contact: contact,
            link: window.location.href.split('?')[0].split('#')[0]
          }
        });
      });
      document.addEventListener('crawl', function (event) {
        var link = event.detail.link;
        chrome.runtime.sendMessage({
          crawl: true,
          data: {
            type: 'crawlBtn',
            link: link
          }
        });
      });

      var configScript = document.createElement('script');
      configScript.id = '__configScript';
      configScript.innerHTML = '//' + chrome.i18n.getMessage('leadsGrabContactBtn');

      // Add another specific localised label for our (currently) Xing ProBusiness-specific
      // `grabAll` button. This is kind of hacky, but there is no bridge between
      // Chrome's localisation functionality and our server-side delivered scripts.
      // So we need to to localisation either in our page-specific scripts or pipe
      // localisations through the DOM via these script tags.
      var grabAllButtonConfigScript = document.createElement('script');
      grabAllButtonConfigScript.id = '__grabAllButtonConfigScript';
      grabAllButtonConfigScript.innerHTML = '//' + chrome.i18n.getMessage('leadsGrabAllContactsBtn');

      if (document && document.head && document.head.appendChild) {
        document.head.appendChild(configScript);
        document.head.appendChild(grabAllButtonConfigScript);
      }

      chrome.storage.local.get('enableGoogleButtons', function (o) {

        // if enableGoogleButtons is not set yet -> show them
        if (!o || o.enableGoogleButtons === undefined || o.enableGoogleButtons === null) {
          o.enableGoogleButtons = true;
        }

        var configScript2 = document.createElement('script');
        configScript2.id = '__enableGoogleButtons';
        configScript2.innerHTML = '//' + ((!o.enableGoogleButtons) ? 'false' : 'true');

        if (document && document.head && document.head.appendChild) {
          document.head.appendChild(configScript2);
        }

        var btnScript = document.createElement('script');
        var link = encodeURIComponent(window.location.href);
        btnScript.src = SERVER_URL + '/getScript?link=' + link;

        if (document && document.head && document.head.appendChild) {
          document.head.appendChild(btnScript);
        }
      });
    }
  });
}

// TODO: Currently unused way to access clipboard, eventually use again to retrieve text from outside of websites
// http://stackoverflow.com/questions/22702446/how-to-get-clipboard-data-in-chrome-extension
// function getTextFromClipboard() {
// 	var input = document.createElement('textarea');
// 	// input.style.display = 'none';
// 	document.body.appendChild(input);
// 	input.focus();
// 	var test = document.execCommand('paste');
// 	var ret = input.value;
// 	document.body.removeChild(input);
// 	return ret;
// }

// handle keyDown event
function onKeyDownHandler(event, state) {
  // If CTRL + C is pressed
  if (67 === event.keyCode && event.ctrlKey) {
    //console.log('CTRL + C called');
    var timeStamp = new Date().getTime();
    // And last time CTRL + C was pressed is under the trigger limit
    if (timeStamp - state.lastCtrlCTimestamp < state.TRIGGER_SNAP_ADDY_LIMIT) {
      // Trigger Snap Addy!
      chrome.storage.local.get('enableShortcut', function (o) {
        if (o.enableShortcut) {
          chrome.runtime.sendMessage({
            snapMe: getCurrentSelectionAsText()
          });
        }
      });
    }
    state.lastCtrlCTimestamp = timeStamp;
    // console.log(state.lastCtrlCTimestamp);
  }
}

/**
 * Object to encapsulate the global state to make functions more testable
 */
var state = {
  TRIGGER_SNAP_ADDY_LIMIT: 500,
  lastCtrlCTimestamp: 0
};

// Listen to KeyDown
document.onkeydown = function (event) {
  onKeyDownHandler(event, state);
};

if (document.querySelector('html[ng-app="snapaddyAnalytics"]')) {

  // send VisitReport Export message to grabber
  document.addEventListener('snapaddy_visitreport_export', function (event) {
    var data = JSON.parse(JSON.stringify(event.detail));
    data.type = 'visitReportExport';
    chrome.runtime.sendMessage({
      visitReport: true,
      data: data
    });
  });

  // get notified when grabber export is finished
  chrome.runtime.onMessage.addListener(function (request) {
    if (request.visitReportDone) {
      try {
        var clonedDetail = cloneInto({
          visitReportDone: request.visitReportDone,
          success: request.success,
          msg: request.msg
        }, document.defaultView);
        document.dispatchEvent(new CustomEvent('snapaddy_visitreport_export_done', {
          detail: clonedDetail
        }));
      } catch (e) {
        console.log(e);
        document.dispatchEvent(new CustomEvent('snapaddy_visitreport_export_done', {
          detail: request
        }));
      }
    }
  });


  // for checking if grabber is installed
  var pingInterval = setInterval(function () {
    var evt = new CustomEvent('snapaddy_grabber_ping');
    document.dispatchEvent(evt);
  }, 1000);

  document.addEventListener('snapaddy_grabber_pong', function () {
    if (pingInterval) {
      clearInterval(pingInterval);
    }
  });


}

// Listen to message to retrieve current selection
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.getSelection) {
      // Notify background page about successful retrieval of the message
      sendResponse({
        inProgress: true
      });
      var selection = getCurrentSelectionAsText();
      // FIXME: empty selection on frame does not trigger the popup if this is not done
      if (!selection) {
        selection = ' ';
      }
      chrome.runtime.sendMessage({
        snapMe: selection
      });
    }
  }
);


// Add eventlistener to open the Grabber via customEvent from any website 
// (contentscript.js is injected into every page)
var OPEN_POPUP_EVENT_TYPE = 'snapaddy_grabber_open';
document.addEventListener(OPEN_POPUP_EVENT_TYPE, function () {
  chrome.runtime.sendMessage({ openPopup: true });
});

chrome.storage.local.get('SNAPADDY_SERVER', function (result) {
  if (result.SNAPADDY_SERVER) {
    SERVER_URL = result.SNAPADDY_SERVER + 'grabberButtons';
  }

  insertCrocoScript();
});
